3 # $NetBSD: rc,v 1.170 2014/07/29 20:39:16 apb Exp $
6 # Run the scripts in /etc/rc.d with rcorder, and log output
9 # System startup script run by init(8) on autoboot or after single-user.
10 # Output and error are redirected to console by init, and the console
11 # is the controlling terminal.
14 export PATH
=/sbin
:/bin
:/usr
/sbin
:/usr
/bin
17 if [ -e .
/rc.subr
] ; then
18 . .
/rc.subr
# for testing
25 : ${RC_LOG_FILE:="/var/run/rc.log"}
27 # rc.subr redefines echo and printf. Undo that here.
28 unset echo ; unalias echo
29 unset printf ; unalias printf
31 if ! checkyesno rc_configured
; then
32 echo "/etc/rc.conf is not configured. Multiuser boot aborted."
36 if [ "$1" = autoboot
]; then
38 rc_fast
=yes # run_rc_command(): do fast booting
42 # Completely ignore INT and QUIT at the outer level. The rc_real_work()
43 # function should do something different.
48 # This string will be used to mark lines of meta-data sent over the pipe
49 # from the rc_real_work() function to the rc_postprocess() function. Lines
50 # not so marked are assumed to be output from rc.d scripts.
52 # This string is long and unique to ensure that it does not accidentally
53 # appear in output from any rc.d script. It must not contain any
54 # characters that are special to glob expansion ('*', '?', '[', or ']').
56 rc_metadata_prefix
="$0:$$:metadata:";
58 # Child scripts may sometimes want to print directly to the original
59 # stdout and stderr, bypassing the pipe to the postprocessor. These
60 # _rc_*_fd variables are private, shared with /etc/rc.subr, but not
61 # intended to be used directly by child scripts. (Child scripts
62 # may use rc.subr's no_rc_postprocess function.)
64 _rc_original_stdout_fd
=7; export _rc_original_stdout_fd
65 _rc_original_stderr_fd
=8; export _rc_original_stderr_fd
66 eval "exec ${_rc_original_stdout_fd}>&1"
67 eval "exec ${_rc_original_stderr_fd}>&2"
71 # Do the real work. Output from this function will be piped into
72 # rc_postprocess(), and some of the output will be marked as
75 # The body of this function is defined using (...), not {...}, to force
76 # it to run in a subshell.
82 # print_rc_metadata() wants to be able to print to the pipe
83 # that goes to our postprocessor, even if its in a context
84 # with redirected output.
86 _rc_postprocessor_fd
=9 ; export _rc_postprocessor_fd
87 _rc_pid
=$$
; export _rc_pid
88 eval "exec ${_rc_postprocessor_fd}>&1"
90 # Print a metadata line when we exit
92 trap 'es=$?; print_rc_metadata "exit:$es"; trap "" 0; exit $es' 0
94 # Set shell to ignore SIGINT, but children will not ignore it.
95 # Shell catches SIGQUIT and returns to single user.
98 trap '_msg="Boot interrupted at $(date)";
99 print_rc_metadata "interrupted:${_msg}";
102 print_rc_metadata
"start:$(date)"
105 # The stop_boot() function in rc.subr may kill $RC_PID. We want
106 # it to kill the subshell running this rc_real_work() function,
107 # rather than killing the parent shell, because we want the
108 # rc_postprocess() function to be able to log the error
109 # without being killed itself.
111 # "$$" is the pid of the top-level shell, not the pid of the
112 # subshell that's executing this function. The command below
113 # tentatively assumes that the parent of the "/bin/sh -c ..."
114 # process will be the current subshell, and then uses "kill -0
115 # ..." to check the result. If the "/bin/sh -c ..." process
116 # fails, or returns the pid of an ephemeral process that exits
117 # before the "kill" command, then we fall back to using "$$".
119 RC_PID
=$
(/bin
/sh
-c 'ps -p $$ -o ppid=') || RC_PID
=$$
120 kill -0 $RC_PID >/dev
/null
2>&1 || RC_PID
=$$
123 # As long as process $RC_PID is still running, send a "nop"
124 # metadata message to the postprocessor every few seconds.
125 # This should help flush partial lines that may appear when
126 # rc.d scripts that are NOT marked with "KEYWORD: interactive"
127 # nevertheless attempt to print prompts and wait for input.
130 # First detach from tty, to avoid intercepting SIGINFO.
131 eval "exec ${_rc_original_stdout_fd}<&-"
132 eval "exec ${_rc_original_stderr_fd}<&-"
133 exec </dev
/null
>/dev
/null
2>&1
134 while kill -0 $RC_PID ; do
135 print_rc_metadata
"nop"
141 # Get a list of all rc.d scripts, and use rcorder to choose
142 # what order to execute them.
144 # For testing, allow RC_FILES_OVERRIDE from the environment to
147 print_rc_metadata
"cmd-name:rcorder"
148 scripts
=$
(for rcd
in ${rc_directories:-/etc/rc.d}; do
149 test -d ${rcd} && echo ${rcd}/*;
151 files
=$
(rcorder
-s nostart
${rc_rcorder_flags} ${scripts})
152 print_rc_metadata
"cmd-status:rcorder:$?"
154 if [ -n "${RC_FILES_OVERRIDE}" ]; then
155 files
="${RC_FILES_OVERRIDE}"
159 # Run the scripts in order.
161 for _rc_elem
in $files; do
162 print_rc_metadata
"cmd-name:$_rc_elem"
163 run_rc_script
$_rc_elem start
164 print_rc_metadata
"cmd-status:$_rc_elem:$?"
167 print_rc_metadata
"end:$(date)"
173 # Post-process the output from the rc_real_work() function. For
174 # each line of input, we have to decide whether to print the line
175 # to the console, print a twiddle on the console, print a line to
176 # the log, or some combination of these.
178 # If rc_silent is true, then suppress most output, instead running
179 # rc_silent_cmd (typically "twiddle") for each line.
181 # The body of this function is defined using (...), not {...}, to force
182 # it to run in a subshell.
184 # We have to deal with the following constraints:
186 # * There may be no writable file systems early in the boot, so
187 # any use of temporary files would be problematic.
189 # * Scripts run during the boot may clear /tmp and/var/run, so even
190 # if they are writable, using those directories too early may be
191 # problematic. We assume that it's safe to write to our log file
192 # after the mountcritlocal script has run.
194 # * /usr/bin/tee cannot be used because the /usr file system may not
195 # be mounted early in the boot.
197 # * All calls to the rc_log_message and rc_log_flush functions must be
198 # from the same subshell, otherwise the use of a shell variable to
199 # buffer log messages will fail.
207 # Try quite hard to flush the log to disk when we exit.
208 trap 'es=$?; rc_log_flush FORCE; trap "" 0; exit $es' 0
210 yesno_to_truefalse rc_silent
2>/dev
/null
212 while read -r line
; do
214 "${rc_metadata_prefix}"*)
215 after
="${line#*"${rc_metadata_prefix}"}"
216 rc_postprocess_metadata
"${after}"
218 *"${rc_metadata_prefix}"*)
219 # magic string is present, but not at the start of
220 # the line. Treat it as a partial line of
221 # ordinary data, followed by a line of metadata.
222 before
="${line%"${rc_metadata_prefix}"*}"
223 rc_postprocess_partial_line
"${before}"
224 after
="${line#*"${rc_metadata_prefix}"}"
225 rc_postprocess_metadata
"${after}"
228 rc_postprocess_plain_line
"${line}"
233 # If we get here, then the rc_real_work() function must have
234 # exited uncleanly. A clean exit would have been accompanied by
235 # a line of metadata that would have prevented us from getting
242 # rc_postprocess_plain_line string
243 # $1 is a string representing a line of output from one of the
244 # rc.d scripts. Append the line to the log, and also either
245 # display the line on the console, or run $rc_silent_cmd,
246 # depending on the value of $rc_silent.
248 rc_postprocess_plain_line
()
251 rc_log_message
"${line}"
253 eval "$rc_silent_cmd"
255 printf "%s\n" "${line}"
260 # rc_postprocess_partial_line string
261 # This is just like rc_postprocess_plain_line, except that
262 # a newline is not appended to the string.
264 rc_postprocess_partial_line
()
267 rc_log_message_n
"${line}"
269 eval "$rc_silent_cmd"
271 printf "%s" "${line}"
276 # rc_postprocess_metadata string
277 # $1 is a string containing metadata from the rc_real_work()
278 # function. The rc_metadata_prefix marker should already
279 # have been removed before the string is passed to this function.
280 # Take appropriate action depending on the content of the string.
282 rc_postprocess_metadata
()
289 # given metadata="bleep:foo bar:baz",
290 # set keyword="bleep", args="foo bar:baz",
291 # $1="foo bar", $2="baz"
293 keyword
="${metadata%%:*}"
294 args
="${metadata#*:}"
299 # Marks the start of the entire /etc/rc script.
300 # $args contains a date/time.
301 rc_log_message
"[$0 starting at $args]"
302 if ! $rc_silent; then
303 # MINIX 3: the clock has not been set yet!
304 #printf "%s\n" "$args"
309 # Marks the start of a child script (usually one of
310 # the /etc/rc.d/* scripts).
311 rc_log_message
"[running $1]"
314 # Marks the end of a child script.
315 # $1 is a command name, $2 is the command's exit status.
316 # If the command failed, report it, and add it to a list.
317 if [ "$2" != 0 ]; then
318 rc_failures
="${rc_failures}${rc_failures:+ }$1"
319 msg
="$1 $(human_exit_code $2)"
320 rc_log_message
"$msg"
321 if ! $rc_silent; then
325 # After the mountcritlocal script has finished, it's
326 # OK to flush the log to disk
335 # This has the side effect of flushing partial lines,
336 # and the echo() and printf() functions in rc.subr take
340 # Unlike most metadata messages, which should be used
341 # only by /etc/rc and rc.subr, the "note" message may be
342 # used directly by /etc.rc.d/* and similar scripts.
343 # It adds a note to the log file, without displaying
345 rc_log_message
"[NOTE: $args]"
348 # Marks the end of processing, after the last child script.
349 # If any child scripts (or other commands) failed, report them.
351 if [ -n "$rc_failures" ]; then
352 rc_log_message
"[failures]"
353 msg
="The following components reported failures:"
354 msg
="${msg}${nl}$( echo " ${rc_failures}" |
fmt )"
355 msg="${msg}${nl}See ${RC_LOG_FILE} for more information.
"
356 rc_log_message "${msg}"
357 printf "%s
\n" "${msg}"
360 # Report the end date/time, even in silent mode
362 rc_log_message "[$0 finished
at $args]"
363 printf "%s
\n" "$args"
366 # Marks an exit from the rc_real_work() function.
367 # This may be a normal or abnormal exit.
369 rc_log_message "[$0 exiting with status
$1]"
373 # Marks an interrupt trapped by the rc_real_work() function.
374 # $args is a human-readable message.
375 rc_log_message "$args"
376 printf "%s
\n" "$args"
379 # an unrecognised line of metadata
380 rc_log_message "[metadata
:${metadata}]"
386 # rc_log_message string [...]
387 # Write a message to the log file, or buffer it for later.
388 # This function appends a newline to the message.
392 _rc_log_buffer="${_rc_log_buffer}${*}${nl}"
397 # rc_log_message_n string [...]
398 # Just like rc_log_message, except without appending a newline.
402 _rc_log_buffer="${_rc_log_buffer}${*}"
407 # rc_log_flush [OK|FORCE]
408 # save outstanding messages from $_rc_log_buffer to $RC_LOG_FILE.
410 # The log file is expected to reside in the /var/run directory, which
411 # may not be writable very early in the boot sequence, and which is
412 # erased a little later in the boot sequence. We therefore avoid
413 # writing to the file until we believe it's safe to do so. We also
414 # assume that it's reasonable to always append to the file, never
417 # Optional argument $1 may be "OK
" to report that writing to the log
418 # file is expected to be safe from now on, or "FORCE
" to force writing
419 # to the log file even if it may be unsafe.
421 # Returns a non-zero status if messages could not be written to the
427 # If $_rc_log_flush_ok is false, then it's probably too early to
428 # write to the log file, so don't do it, unless $1 is "FORCE
".
430 : ${_rc_log_flush_ok=false}
431 case "$1:$_rc_log_flush_ok" in
433 _rc_log_flush_ok=true
442 # it's too early in the boot sequence, so don't flush
448 # Now append the buffer to the file. The buffer should already
449 # contain a trailing newline, so don't add an extra newline.
451 if [ -n "$_rc_log_buffer" ]; then
452 if { printf "%s
" "${_rc_log_buffer}" >>"${RC_LOG_FILE}" ; } \
464 # Most of the action is in the rc_real_work() and rc_postprocess()
467 rc_real_work
"$@" 2>&1 | rc_postprocess